print("Hello from Lua")
require("table")
require("math")
package.path = package.path .. ";lua/?.lua"
require("utils")
require("Luvent")
package.path = package.path .. ";lua/lua-files/?.lua"

class = require "middleclass"
Luvent = require "Luvent"

coin = class("coin");

zone = class("zone");

effect = class("effect");

--coin.static.coins={}

--zone.static.onInZone = Luvent.newEvent()

coin.static.onDie = Luvent.newEvent()



score={}
score[0]=0
score[1]=0
currentPlayer=0


function Set (list)
  local set = {}
  for _, l in ipairs(list) do set[l] = true end
  return set
end


local debugAction = coin.onDie:addAction(
    function (index)
        print(string.format("Coin %i dropped",index))
	score[coins[index].player]=score[coins[index].player]+1
    end)


    --[[
local collisionAction = coin.onCollide:addAction(
    function (self,index)
        coins[index].player=self.player;
    end)
    ]]--

    --[[
local onInZoneAction = zone.onInZone:addAction(
    function (coin)
        coins[coin].friction=0;
	printf("%i", coin);
    end)
]]--
function coin:initialize(id)
	self.mass=0.05;
	self.Ixx=0.2;
	self.Iyy=0.2;
	self.Izz=5;
	self.linDamp=0.0;
	self.angDamp=0.1;
	self.friction=0.9;
	self.restitution=0.5;
	self.posX=0.0;
	self.posY=0.0;
	self.posZ=0;
	self.player=0;
	self.visible=1;
	self.texture="tex1";
	printf("creating coin %i", id);
	--createCoin(id,self);
end

function coin:debugOtput()
	printf("visibility: ,%s", tostring(self.visible));
	--createCoin(id,self);
end


function zone:initialize(id)
	self.anchor=0;
	--self.type="sphere";
	--self.radius=1.0;
	self.contour={}
	--[[
	for t =0, 2*3.14, 0.4 do
		--printf("%f",t);
		table.insert(self.contour,{12.0*math.cos(t),12.0*math.sin(t)});
		table.insert(self.contour,{16.0*math.cos(t+0.2),16.0*math.sin(t+0.2)});
	end;
	]]--
	--[[self.contour = {
	    {-4.0,-4.0},
	    {-4.0, 4.0},
	    { 4.0,-4.0}
	}
	]]
	self.offset={0.0,0.0};
	self.texture="none";
	--createZone(id,self);
end

function zone:destroy(id)
	zones[id]=nil
end


local zoneDestroyAction = coin.onDie:addAction(
	function (index)
		for i, z in pairs(zones) do
			if (z.anchor == index) then
				zone:destroy(i)
				printf("zone %i removed",i);
				syncZones()
			end
		end
	end)

forceMult = 1;
forceMin = 1.0;
forceMax = 15.0;

dofile("lua/level.lua")


prevZoneIntersectionState = {};
prevZoneIntersectionState[1] = {};
prevZoneIntersectionState[2] = {};
prevZoneIntersectionState[3] = {};
curZoneIntersectionState = {};
curZoneIntersectionState[1] = {};
curZoneIntersectionState[2] = {};
curZoneIntersectionState[3] = {};

 for i, z in pairs(zones) do
	prevZoneIntersectionState[i] = {};
	curZoneIntersectionState[i] = {};
 end


function applyEffects()

    --printf("visibility: ,%s", tostring(coins[1].visible));
    --coins[1]:debugOutput();


    for i, v in pairs(coins) do
      --printf("%f \n",coins[i].posZ);
	  if not (hitTest(coins[i].posX,coins[i].posY,100,coins[i].posX,coins[i].posY,-100)) then
		printf("coin %i removed",i);
		coin.onDie:trigger(i)
		coins[i]=nil
	  end
    end


   --printf("lalala");
    --local zoneHit  ={};
    for i, z in pairs(zones) do
	--printf("%i \n",i);
	curZoneIntersectionState[i] = {queryZone(i,zones[i].anchor)}

	for j, c in pairs(curZoneIntersectionState[i]) do
		--printf("coin %i in zone %i \n",c,i);
		zones[i].onInZone:trigger(c);
	end


	prevItems=Set(prevZoneIntersectionState[i])
	--printtable(prevItems);

	curItems=Set(curZoneIntersectionState[i])
	--printtable(curItems);



	for j, c in pairs(curZoneIntersectionState[i]) do
		if (not prevItems[c]) then
			zones[i].onEnterZone:trigger(c);
			printf("coin %i entered zone %i \n",c,i);
		end
	end

	for j, c in pairs(prevZoneIntersectionState[i]) do
		if (not curItems[c]) then
			zones[i].onLeaveZone:trigger(c);
			printf("coin %i left zone %i \n",c,i);
		end
	end



	prevZoneIntersectionState[i]=deepcopy(curZoneIntersectionState[i]);
    end;
    --prevZoneIntersectionState=deepcopy(curZoneIntersectionState);

    return 1
end

function doNothing()
end


function getCoinKeys()
	local keyset={}
	local n=0

	for k,v in pairs(coins) do
	  n=n+1
	  keyset[n]=k
      --printf("key: %i \n",k);
	end
	return keyset
end

function getKeys(targetTable)
	local keyset={}
	local n=0

	for k,v in pairs(_G[targetTable]) do
	  n=n+1
	  keyset[n]=k
      --printf("key: %i \n",k);
	end
	return keyset
end

